#define _GNU_SOURCE
#include <assert.h>
#include <stdio.h>
#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    int i = 0;
    char* s = NULL;
    cgul_exception_t local = NULL;

    for (i = 0 ; i < 1000 ; ++i) {
#if 1
        s = cgul_libc__asprintf(&local, "%d: %s", i, "Hello, World!");
#else
        asprintf(&s, "%d: %s", i, "Hello, World!");
#endif
        cgul_libc__puts(&local, s);
        if (s) {
            free(s);
        }
        if (local) {
            break;
        }
    }

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    return rv;
}
