#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    int i_max = 0;
    cgul_exception_t local = NULL;
    struct {
        const char* s1;
        const char* s2;
    } test_strings[] = {
        {"", ""},
        {"", "a"},
        {"", "ab"},
        {"", "abc"},
        {"a", ""},
        {"ab", ""},
        {"abc", ""},
        {"a", "a"},
        {"ab", "a"},
        {"abc", "a"},
        {"ab", "ab"},
        {"abc", "abc"},
    };
    char test_chars[] = {
        'b', 'a', 'r',
        ' ', '\t', '\n', '\r', '\f', '\v',
        '\0' /* sentinel */
    };

    /* Compare a few strings. */
    i_max = sizeof(test_strings) / sizeof(test_strings[0]);
    for (i = 0 ; i < i_max ; ++i) {
        const char* s1  = test_strings[i].s1;
        const char* s2  = test_strings[i].s2;
        printf("cgul_char__strcmp(\"%s\", \"%s\") = %d\n",
               s1, s2, cgul_char__strcmp(s1, s2));
    }

    /* Compare each test character to see if it is a space. */
    for (i = 0 ; test_chars[i] ; ++i) {
        printf("%3d: %d\n",
               test_chars[i],
               cgul_char__isspace(&local, test_chars[i]));
    }

    return rv;
}
