#include "cgul_cxx.h"

int main(int argc,
         char* argvp[])
{
    int rv = 0;
    size_t i = 0;
    cgul_wchar_t hello[] = {'h', 'e', 'l', 'l', 'o', 0};

    try {

        cgul_wstring_cxx ws;
        ws.append(hello);
        ws.pad_right(10, (cgul_wchar_t)' ');

        for (i = 0 ; i < ws.get_length() ; ++i) {
            cgul_wchar_t c = ws[i];
            printf("c = %lu\n", (long unsigned)c);
        }

    } catch (const cgul_exception_cxx& e) {
        fprintf(stderr, "*** Error: %s\n", e.get_message());
        rv = 1;
    }

    return rv;
}
