#include <stdio.h>
#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 1;
    cgul_exception_t local = NULL;

    /* Copy stdin to stdout. */
    cgul_libc__copy_file(&local, stdin, stdout);
    if (local) {
        goto out;
    }

    /* Success. */
    rv = 0;

 out:

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    return rv;
}
