#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_uint32_t x = 0;
    cgul_uint32_t y = 0;
    cgul_uint32_t high = 0;
    cgul_uint32_t low = 0;
    cgul_exception_t local = NULL;

    x = 0xaaaabbbb;
    y = 0xccccdddd;
    cgul_multiply64(&local, x, y, &high, &low);
    printf("%#0x * %#0x = %#0x%08x\n", x, y, high, low);

    x = 0xaaaa0000;
    y = 0x100;
    cgul_multiply64(&local, x, y, &high, &low);
    printf("%#0x * %#0x = %#0x%08x\n", x, y, high, low);

    return rv;
}
