#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    int len = 0;
    cgul_exception_t local = NULL;
    char buf[5];

    cgul_libc__memset(&local, buf, '@', sizeof(buf));
    len = cgul_libc__snprintf(&local, buf, sizeof(buf), "%g", 1234567890.0);
    cgul_libc__printf(&local, "buf = %s\n", buf);
    cgul_libc__printf(&local, "expanded length would be = %d\n", len);

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    return rv;
}
